Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 6725)
@@ -0,0 +1,601 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Linq;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Clients.Hive {
+  public class RefreshableJob : IHiveItem, IDeepCloneable, IContent, IProgressReporter, IComparable<RefreshableJob> {
+    private JobResultPoller jobResultPoller;
+    private ConcurrentTaskDownloader<ItemTask> jobDownloader;
+    private static object locker = new object();
+
+    private Job job;
+    public Job Job {
+      get { return job; }
+      set {
+        if (value != job) {
+          if (value == null)
+            throw new ArgumentNullException();
+
+          if (job != null) DergisterJobEvents();
+          job = value;
+          if (job != null) {
+            RegisterJobEvents();
+            job_PropertyChanged(job, new PropertyChangedEventArgs("Id"));
+          }
+          OnJobChanged();
+          OnToStringChanged(this, EventArgs.Empty);
+        }
+      }
+    }
+
+    private ItemCollection<HiveTask> hiveJobs;
+    public ItemCollection<HiveTask> HiveJobs {
+      get { return hiveJobs; }
+      set {
+        if (hiveJobs != value) {
+          if (hiveJobs != null) DeregisterHiveJobsEvents();
+          hiveJobs = value;
+          if (hiveJobs != null) RegisterHiveJobsEvents();
+          OnHiveJobsChanged();
+        }
+      }
+    }
+
+    private ExecutionState executionState;
+    public ExecutionState ExecutionState {
+      get { return executionState; }
+      internal set {
+        if (executionState != value) {
+          executionState = value;
+          OnExecutionStateChanged();
+        }
+      }
+    }
+
+    private TimeSpan executionTime;
+    public TimeSpan ExecutionTime {
+      get { return executionTime; }
+      internal set {
+        if (executionTime != value) {
+          executionTime = value;
+          OnExecutionTimeChanged();
+        }
+      }
+    }
+
+    private bool refreshAutomatically;
+    public bool RefreshAutomatically {
+      get { return refreshAutomatically; }
+      set {
+        lock (locker) {
+          if (refreshAutomatically != value) {
+            refreshAutomatically = value;
+            OnRefreshAutomaticallyChanged();
+          }
+          if (RefreshAutomatically) {
+            if (this.HiveJobs != null && this.HiveJobs.Count > 0 && (jobResultPoller == null || !jobResultPoller.IsPolling)) {
+              StartResultPolling();
+            }
+          } else {
+            StopResultPolling();
+          }
+        }
+      }
+    }
+
+    // indicates if download button is enabled
+    private bool isDownloadable = true;
+    public bool IsDownloadable {
+      get { return isDownloadable; }
+      set {
+        if (value != isDownloadable) {
+          isDownloadable = value;
+          OnIsDownloadableChanged();
+        }
+      }
+    }
+
+    // if true, all control buttons should be enabled. otherwise disabled
+    private bool isControllable = true;
+    public bool IsControllable {
+      get { return isControllable; }
+      private set {
+        if (value != isControllable) {
+          isControllable = value;
+          OnIsControllableChanged();
+          if (this.hiveJobs != null) {
+            foreach (var hiveJob in this.hiveJobs) {
+              hiveJob.IsControllable = value;
+            }
+          }
+        }
+      }
+    }
+
+    // indicates if a user is allowed to share this experiment
+    private bool isSharable = true;
+    public bool IsSharable {
+      get { return isSharable; }
+      private set {
+        if (value != isSharable) {
+          isSharable = value;
+          OnIsSharableChanged();
+        }
+      }
+    }
+
+    // may execute jobs with privileged permissions on slaves
+    private bool isAllowedPrivileged = true;
+    public bool IsAllowedPrivileged {
+      get { return isAllowedPrivileged; }
+      set {
+        if (value != isAllowedPrivileged) {
+          isAllowedPrivileged = value;
+          OnIsAllowedPrivilegedChanged();
+        }
+      }
+    }
+
+    private bool isProgressing;
+    public bool IsProgressing {
+      get { return isProgressing; }
+      set {
+        if (isProgressing != value) {
+          isProgressing = value;
+          OnIsProgressingChanged();
+        }
+      }
+    }
+
+    private IProgress progress;
+    public IProgress Progress {
+      get { return progress; }
+      set { this.progress = value; }
+    }
+
+    private ThreadSafeLog log;
+    public ILog Log {
+      get { return log; }
+    }
+
+    public StateLogListList StateLogList {
+      get { return new StateLogListList(this.GetAllHiveJobs().Select(x => x.StateLog)); }
+    }
+
+    #region Constructors and Cloning
+    public RefreshableJob() {
+      this.refreshAutomatically = true;
+      this.Job = new Job();
+      this.log = new ThreadSafeLog(new Log());
+      this.jobDownloader = new ConcurrentTaskDownloader<ItemTask>(2, 2);
+      this.jobDownloader.ExceptionOccured += new EventHandler<EventArgs<Exception>>(jobDownloader_ExceptionOccured);
+      this.HiveJobs = new ItemCollection<HiveTask>();
+    }
+    public RefreshableJob(Job hiveExperiment) {
+      this.refreshAutomatically = true;
+      this.Job = hiveExperiment;
+      this.log = new ThreadSafeLog(new Log());
+      this.jobDownloader = new ConcurrentTaskDownloader<ItemTask>(2, 2);
+      this.jobDownloader.ExceptionOccured += new EventHandler<EventArgs<Exception>>(jobDownloader_ExceptionOccured);
+      this.HiveJobs = new ItemCollection<HiveTask>();
+    }
+    protected RefreshableJob(RefreshableJob original, Cloner cloner) {
+      cloner.RegisterClonedObject(original, this);
+      this.Job = original.Job;
+      this.IsControllable = original.IsControllable;
+      this.log = cloner.Clone(original.log);
+      this.RefreshAutomatically = false; // do not start results polling automatically
+      this.jobDownloader = new ConcurrentTaskDownloader<ItemTask>(2, 2);
+      this.jobDownloader.ExceptionOccured += new EventHandler<EventArgs<Exception>>(jobDownloader_ExceptionOccured);
+      this.HiveJobs = cloner.Clone(original.HiveJobs);
+      this.ExecutionTime = original.ExecutionTime;
+      this.ExecutionState = original.ExecutionState;
+    }
+    public IDeepCloneable Clone(Cloner cloner) {
+      return new RefreshableJob(this, cloner);
+    }
+    public object Clone() {
+      return this.Clone(new Cloner());
+    }
+    #endregion
+
+    #region JobResultPoller Events
+
+    public void StartResultPolling() {
+      if (jobResultPoller == null) {
+        jobResultPoller = new JobResultPoller(job.Id, /*ApplicationConstants.ResultPollingInterval*/new TimeSpan(0, 0, 5)); //TODO: find a better place for ApplicationConstants
+        RegisterResultPollingEvents();
+        jobResultPoller.AutoResumeOnException = true;
+      }
+
+      if (!jobResultPoller.IsPolling) {
+        jobResultPoller.Start();
+      }
+    }
+
+    public void StopResultPolling() {
+      if (jobResultPoller != null && jobResultPoller.IsPolling) {
+        jobResultPoller.Stop();
+      }
+    }
+
+    private void RegisterResultPollingEvents() {
+      jobResultPoller.ExceptionOccured += new EventHandler<EventArgs<Exception>>(jobResultPoller_ExceptionOccured);
+      jobResultPoller.JobResultsReceived += new EventHandler<EventArgs<IEnumerable<LightweightTask>>>(jobResultPoller_JobResultReceived);
+      jobResultPoller.IsPollingChanged += new EventHandler(jobResultPoller_IsPollingChanged);
+    }
+    private void DeregisterResultPollingEvents() {
+      jobResultPoller.ExceptionOccured -= new EventHandler<EventArgs<Exception>>(jobResultPoller_ExceptionOccured);
+      jobResultPoller.JobResultsReceived -= new EventHandler<EventArgs<IEnumerable<LightweightTask>>>(jobResultPoller_JobResultReceived);
+      jobResultPoller.IsPollingChanged -= new EventHandler(jobResultPoller_IsPollingChanged);
+    }
+    private void jobResultPoller_IsPollingChanged(object sender, EventArgs e) {
+      if (this.refreshAutomatically != jobResultPoller.IsPolling) {
+        this.refreshAutomatically = jobResultPoller.IsPolling;
+        OnRefreshAutomaticallyChanged();
+      }
+    }
+    private void jobResultPoller_JobResultReceived(object sender, EventArgs<IEnumerable<LightweightTask>> e) {
+      foreach (LightweightTask lightweightJob in e.Value) {
+        HiveTask hiveJob = GetHiveJobById(lightweightJob.Id);
+        if (hiveJob != null) {
+          // lastJobDataUpdate equals DateTime.MinValue right after it was uploaded. When the first results are polled, this value is updated
+          if (hiveJob.Task.State == TaskState.Offline && lightweightJob.State != TaskState.Finished && lightweightJob.State != TaskState.Failed && lightweightJob.State != TaskState.Aborted) {
+            hiveJob.Task.LastJobDataUpdate = lightweightJob.LastJobDataUpdate;
+          }
+
+          hiveJob.UpdateFromLightweightJob(lightweightJob);
+
+          if (!hiveJob.IsFinishedTaskDownloaded && !hiveJob.IsDownloading && hiveJob.Task.LastJobDataUpdate < lightweightJob.LastJobDataUpdate) {
+            log.LogMessage(string.Format("Downloading task {0}", lightweightJob.Id));
+            hiveJob.IsDownloading = true;
+            jobDownloader.DownloadJob(hiveJob.Task, (localJob, itemJob) => {
+              log.LogMessage(string.Format("Finished downloading task {0}", localJob.Id));
+              HiveTask localHiveJob = GetHiveJobById(localJob.Id);
+
+              if (itemJob == null) {
+                localHiveJob.IsDownloading = false;
+              }
+
+              if (itemJob == null) {
+                // something bad happened to this task. bad task, BAAAD task!
+              } else {
+                // if the task is paused, download but don't integrate into parent optimizer (to avoid Prepare)
+
+                if (localJob.State == TaskState.Paused) {
+                  localHiveJob.ItemTask = itemJob;
+                } else {
+                  if (localJob.ParentTaskId.HasValue) {
+                    HiveTask parentHiveJob = GetHiveJobById(localJob.ParentTaskId.Value);
+                    parentHiveJob.IntegrateChild(itemJob, localJob.Id);
+                  } else {
+                    localHiveJob.ItemTask = itemJob;
+                  }
+                }
+                localHiveJob.IsDownloading = false;
+                localHiveJob.Task.LastJobDataUpdate = localJob.LastJobDataUpdate;
+              }
+            });
+          }
+        }
+      }
+      GC.Collect(); // force GC, because .NET is too lazy here (deserialization takes a lot of memory)
+      if (AllJobsFinished()) {
+        this.ExecutionState = Core.ExecutionState.Stopped;
+        StopResultPolling();
+      }
+      UpdateTotalExecutionTime();
+      UpdateStatistics();
+      OnStateLogListChanged();
+    }
+
+    public HiveTask GetHiveJobById(Guid jobId) {
+      foreach (HiveTask job in this.HiveJobs) {
+        var hj = job.GetHiveTaskByTaskId(jobId);
+        if (hj != null)
+          return hj;
+      }
+      return null;
+    }
+    private void UpdateStatistics() {
+      var jobs = this.GetAllHiveJobs();
+      job.JobCount = jobs.Count();
+      job.CalculatingCount = jobs.Count(j => j.Task.State == TaskState.Calculating);
+      job.FinishedCount = jobs.Count(j => j.Task.State == TaskState.Finished);
+      OnJobStatisticsChanged();
+    }
+
+    public bool AllJobsFinished() {
+      return this.GetAllHiveJobs().All(j => (j.Task.State == TaskState.Finished
+                                                   || j.Task.State == TaskState.Aborted
+                                                   || j.Task.State == TaskState.Failed)
+                                                   && j.IsFinishedTaskDownloaded);
+    }
+
+    private void jobResultPoller_ExceptionOccured(object sender, EventArgs<Exception> e) {
+      OnExceptionOccured(e.Value);
+    }
+    private void jobDownloader_ExceptionOccured(object sender, EventArgs<Exception> e) {
+      OnExceptionOccured(e.Value);
+    }
+    public void UpdateTotalExecutionTime() {
+      this.ExecutionTime = TimeSpan.FromMilliseconds(this.GetAllHiveJobs().Sum(x => x.Task.ExecutionTime.TotalMilliseconds));
+    }
+    #endregion
+
+    #region Task Events
+    private void RegisterJobEvents() {
+      job.ToStringChanged += new EventHandler(OnToStringChanged);
+      job.PropertyChanged += new PropertyChangedEventHandler(job_PropertyChanged);
+      job.ItemImageChanged += new EventHandler(job_ItemImageChanged);
+      job.ModifiedChanged += new EventHandler(job_ModifiedChanged);
+    }
+
+    private void DergisterJobEvents() {
+      job.ToStringChanged -= new EventHandler(OnToStringChanged);
+      job.PropertyChanged -= new PropertyChangedEventHandler(job_PropertyChanged);
+      job.ItemImageChanged -= new EventHandler(job_ItemImageChanged);
+      job.ModifiedChanged -= new EventHandler(job_ModifiedChanged);
+    }
+    #endregion
+
+    #region Event Handler
+    public event EventHandler RefreshAutomaticallyChanged;
+    private void OnRefreshAutomaticallyChanged() {
+      var handler = RefreshAutomaticallyChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler JobChanged;
+    private void OnJobChanged() {
+      var handler = JobChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler ModifiedChanged;
+    private void job_ModifiedChanged(object sender, EventArgs e) {
+      var handler = ModifiedChanged;
+      if (handler != null) handler(sender, e);
+    }
+
+    public event EventHandler ItemImageChanged;
+    private void job_ItemImageChanged(object sender, EventArgs e) {
+      var handler = ItemImageChanged;
+      if (handler != null) handler(this, e);
+    }
+
+    public event PropertyChangedEventHandler PropertyChanged;
+    private void job_PropertyChanged(object sender, PropertyChangedEventArgs e) {
+      this.IsSharable = job.Permission == Permission.Full;
+      this.IsControllable = job.Permission == Permission.Full;
+
+      var handler = PropertyChanged;
+      if (handler != null) handler(sender, e);
+    }
+
+    public event EventHandler ToStringChanged;
+    private void OnToStringChanged(object sender, EventArgs e) {
+      var handler = ToStringChanged;
+      if (handler != null) handler(this, e);
+    }
+
+    public event EventHandler IsProgressingChanged;
+    protected virtual void OnIsProgressingChanged() {
+      var handler = IsProgressingChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler IsDownloadableChanged;
+    private void OnIsDownloadableChanged() {
+      var handler = IsDownloadableChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler IsControllableChanged;
+    private void OnIsControllableChanged() {
+      var handler = IsControllableChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler IsSharableChanged;
+    private void OnIsSharableChanged() {
+      var handler = IsSharableChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler IsAllowedPrivilegedChanged;
+    private void OnIsAllowedPrivilegedChanged() {
+      var handler = IsAllowedPrivilegedChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler JobStatisticsChanged;
+    private void OnJobStatisticsChanged() {
+      var handler = JobStatisticsChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler<EventArgs<Exception>> ExceptionOccured;
+    private void OnExceptionOccured(Exception exception) {
+      log.LogException(exception);
+      var handler = ExceptionOccured;
+      if (handler != null) handler(this, new EventArgs<Exception>(exception));
+    }
+
+    public event EventHandler StateLogListChanged;
+    private void OnStateLogListChanged() {
+      var handler = StateLogListChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler ExecutionTimeChanged;
+    protected virtual void OnExecutionTimeChanged() {
+      var handler = ExecutionTimeChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler ExecutionStateChanged;
+    protected virtual void OnExecutionStateChanged() {
+      var handler = ExecutionStateChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    #endregion
+
+    #region HiveJobs Events
+    private void RegisterHiveJobsEvents() {
+      this.hiveJobs.ItemsAdded += new CollectionItemsChangedEventHandler<HiveTask>(hiveJobs_ItemsAdded);
+      this.hiveJobs.ItemsRemoved += new CollectionItemsChangedEventHandler<HiveTask>(hiveJobs_ItemsRemoved);
+      this.hiveJobs.CollectionReset += new CollectionItemsChangedEventHandler<HiveTask>(hiveJobs_CollectionReset);
+    }
+
+    private void DeregisterHiveJobsEvents() {
+      this.hiveJobs.ItemsAdded -= new CollectionItemsChangedEventHandler<HiveTask>(hiveJobs_ItemsAdded);
+      this.hiveJobs.ItemsRemoved -= new CollectionItemsChangedEventHandler<HiveTask>(hiveJobs_ItemsRemoved);
+      this.hiveJobs.CollectionReset -= new CollectionItemsChangedEventHandler<HiveTask>(hiveJobs_CollectionReset);
+    }
+
+    private void hiveJobs_CollectionReset(object sender, CollectionItemsChangedEventArgs<HiveTask> e) {
+      foreach (var item in e.Items) {
+        item.StateLogChanged -= new EventHandler(item_StateLogChanged);
+      }
+      OnHiveJobsReset(e);
+    }
+
+    private void hiveJobs_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<HiveTask> e) {
+      foreach (var item in e.Items) {
+        item.StateLogChanged -= new EventHandler(item_StateLogChanged);
+      }
+      OnHiveJobsRemoved(e);
+    }
+
+    private void hiveJobs_ItemsAdded(object sender, CollectionItemsChangedEventArgs<HiveTask> e) {
+      foreach (var item in e.Items) {
+        item.StateLogChanged += new EventHandler(item_StateLogChanged);
+        item.IsControllable = this.IsControllable;
+      }
+      OnHiveJobsAdded(e);
+    }
+
+    private void item_StateLogChanged(object sender, EventArgs e) {
+      OnStateLogListChanged();
+    }
+    #endregion
+
+    public event EventHandler HiveJobsChanged;
+    protected virtual void OnHiveJobsChanged() {
+      if (jobResultPoller != null && jobResultPoller.IsPolling) {
+        jobResultPoller.Stop();
+        DeregisterResultPollingEvents();
+      }
+      if (this.HiveJobs != null && this.HiveJobs.Count > 0 && this.GetAllHiveJobs().All(x => x.Task.Id != Guid.Empty)) {
+        if (this.RefreshAutomatically)
+          StartResultPolling();
+      }
+
+      var handler = HiveJobsChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler Loaded;
+    public virtual void OnLoaded() {
+      this.UpdateTotalExecutionTime();
+
+      if (this.ExecutionState != ExecutionState.Stopped) {
+        this.RefreshAutomatically = true;
+      }
+
+      var handler = Loaded;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler<CollectionItemsChangedEventArgs<HiveTask>> HiveJobsAdded;
+    private void OnHiveJobsAdded(CollectionItemsChangedEventArgs<HiveTask> e) {
+      var handler = HiveJobsAdded;
+      if (handler != null) handler(this, e);
+    }
+
+    public event EventHandler<CollectionItemsChangedEventArgs<HiveTask>> HiveJobsRemoved;
+    private void OnHiveJobsRemoved(CollectionItemsChangedEventArgs<HiveTask> e) {
+      var handler = HiveJobsRemoved;
+      if (handler != null) handler(this, e);
+    }
+
+    public event EventHandler<CollectionItemsChangedEventArgs<HiveTask>> HiveJobsReset;
+    private void OnHiveJobsReset(CollectionItemsChangedEventArgs<HiveTask> e) {
+      var handler = HiveJobsReset;
+      if (handler != null) handler(this, e);
+    }
+
+    public Guid Id {
+      get { return job.Id; }
+      set { job.Id = value; }
+    }
+    public bool Modified {
+      get { return job.Modified; }
+    }
+    public void Store() {
+      job.Store();
+    }
+    public string ItemDescription {
+      get { return job.ItemDescription; }
+    }
+    public Image ItemImage {
+      get { return job.ItemImage; }
+    }
+    public string ItemName {
+      get { return job.ItemName; }
+    }
+    public Version ItemVersion {
+      get { return job.ItemVersion; }
+    }
+
+    public override string ToString() {
+      return string.Format("{0} {1}", Job.DateCreated.ToString("MM.dd.yyyy HH:mm"), Job.ToString());
+    }
+
+    public bool IsFinished() {
+      return HiveJobs != null
+        && HiveJobs.All(x => x.Task.DateFinished.HasValue && x.Task.DateCreated.HasValue);
+    }
+
+    public IEnumerable<HiveTask> GetAllHiveJobs() {
+      if (hiveJobs == null) return Enumerable.Empty<HiveTask>();
+
+      var jobs = new List<HiveTask>();
+      foreach (HiveTask job in HiveJobs) {
+        jobs.AddRange(job.GetAllHiveTasks());
+      }
+      return jobs;
+    }
+
+    public int CompareTo(RefreshableJob other) {
+      return this.ToString().CompareTo(other.ToString());
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveServiceClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveServiceClient.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveServiceClient.cs	(revision 6725)
@@ -59,4 +59,6 @@
 
     public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
+
+
   }
 
@@ -281,5 +283,5 @@
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
-    private bool IsParentJobField;
+    private bool IsParentTaskField;
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
@@ -328,12 +330,12 @@
 
     [System.Runtime.Serialization.DataMemberAttribute()]
-    public bool IsParentJob {
-      get {
-        return this.IsParentJobField;
-      }
-      set {
-        if ((this.IsParentJobField.Equals(value) != true)) {
-          this.IsParentJobField = value;
-          this.RaisePropertyChanged("IsParentJob");
+    public bool IsParentTask {
+      get {
+        return this.IsParentTaskField;
+      }
+      set {
+        if ((this.IsParentTaskField.Equals(value) != true)) {
+          this.IsParentTaskField = value;
+          this.RaisePropertyChanged("IsParentTask");
         }
       }
@@ -1475,8 +1477,8 @@
 
       [System.Runtime.Serialization.EnumMemberAttribute()]
-      CalculateJob = 0,
+      CalculateTask = 0,
 
       [System.Runtime.Serialization.EnumMemberAttribute()]
-      StopJob = 1,
+      StopTask = 1,
 
       [System.Runtime.Serialization.EnumMemberAttribute()]
@@ -1484,5 +1486,5 @@
 
       [System.Runtime.Serialization.EnumMemberAttribute()]
-      AbortJob = 3,
+      AbortTask = 3,
 
       [System.Runtime.Serialization.EnumMemberAttribute()]
@@ -1490,5 +1492,5 @@
 
       [System.Runtime.Serialization.EnumMemberAttribute()]
-      PauseJob = 5,
+      PauseTask = 5,
 
       [System.Runtime.Serialization.EnumMemberAttribute()]
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs	(revision 6725)
@@ -36,5 +36,5 @@
       this.PluginsNeededIds = new List<Guid>(original.PluginsNeededIds);
       this.LastHeartbeat = original.LastHeartbeat;
-      this.IsParentJob = original.IsParentJob;
+      this.IsParentTask = original.IsParentTask;
       this.FinishWhenChildJobsFinished = original.FinishWhenChildJobsFinished;
       this.JobId = original.JobId;
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs	(revision 6725)
@@ -0,0 +1,105 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Clients.Hive.Jobs;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Clients.Hive {
+  public class TaskDownloader {
+    private IEnumerable<Guid> taskIds;
+    private ConcurrentTaskDownloader<ItemTask> taskDownloader;
+    private IDictionary<Guid, HiveTask> results;
+    private bool exceptionOccured = false;
+    private Exception currentException;
+
+    public bool IsFinished {
+      get {
+        return results.Count == taskIds.Count();
+      }
+    }
+
+    public bool IsFaulted {
+      get {
+        return exceptionOccured;
+      }
+    }
+
+    public Exception Exception {
+      get {
+        return currentException;
+      }
+    }
+    
+    public int FinishedCount {
+      get {
+        return results.Count;
+      }
+    }
+
+    public IDictionary<Guid, HiveTask> Results {
+      get {
+        return results;
+      }
+    }
+
+    public TaskDownloader(IEnumerable<Guid> jobIds) {
+      this.taskIds = jobIds;
+      this.taskDownloader = new ConcurrentTaskDownloader<ItemTask>(2, 2);
+      this.taskDownloader.ExceptionOccured += new EventHandler<EventArgs<Exception>>(taskDownloader_ExceptionOccured);
+      this.results = new Dictionary<Guid, HiveTask>();
+    }
+    
+    public void StartAsync() {
+      foreach (Guid jobId in taskIds) {
+        Task job = ServiceLocator.Instance.CallHiveService(s => s.GetJob(jobId));
+
+        taskDownloader.DownloadJob(job,
+          (localJob, itemJob) => {
+            if (localJob != null && itemJob != null) {
+              HiveTask hiveJob;
+              if (itemJob is OptimizerTask) {
+                hiveJob = new OptimizerHiveTask((OptimizerTask)itemJob);
+              } else {
+                hiveJob = new HiveTask(itemJob, true);
+              }
+              hiveJob.Task = localJob;
+              this.results.Add(localJob.Id, hiveJob);
+            }
+          });
+      }      
+    }
+
+    private void taskDownloader_ExceptionOccured(object sender, EventArgs<Exception> e) {
+      OnExceptionOccured(e.Value);
+    }
+
+    public event EventHandler<EventArgs<Exception>> ExceptionOccured;
+    private void OnExceptionOccured(Exception exception) {
+      this.exceptionOccured = true;
+      this.currentException = exception;
+      var handler = ExceptionOccured;
+      if (handler != null) handler(this, new EventArgs<Exception>(exception));
+    }
+  }
+}
